;Coded by UEZ
#AutoIt3Wrapper_UseX64=n
#include <GUIConstantsEx.au3>
#include "WebP.au3"

If WebP_Ver2() < "0.3.0" Then Exit MsgBox($MB_ICONERROR, "ERROR", "DLL Version v0.3.+ required!", 30)

Global $sFile = FileOpenDialog("Select an image to compress", "", "Images (*.jpg;*.bmp;*.png;*.gif;*.tif)")
If @error Then Exit

Global Const $STM_SETIMAGE = 0x0172
_GDIPlus_Startup()
Global $hImage = _GDIPlus_ImageLoadFromFile($sFile), $hHBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)

;Example with maximal lossy compression settings
Global $tMem = WebP_CreateWebPAdvancedFromBitmap("", $hImage, _
																										  0, _		;$WebPPreset (0 - 5)
																										  0, _     	;$lossless (0 - 1)
																										  0, _     	;$quality (0.0 - 100.0)
																										  6, _     	;$method (0 - 6)
																										  0, _     	;$sns_strength (0 - 100)
																										  0, _     	;$filter_sharpness (0 - 7)
																										  0, _     	;$filter_strength (0 - 100)
																										  10, _   	;$pass (1 - 10)
																										  9, _    	;$level (0 - 9) for lossless compression only
																										  100, _ 	;$near_lossless (0 - 100)
																										  1, _    	;$alpha_compression (0 - 1)
																										  2, _    	;$alpha_filtering (0 - 2)
																										  0, _    	;$alpha_quality (0 - 100)
																										  0, _    	;$target_size (0 = off, size in bytes)
																										  True) 	;hold the compressed image in memory only, no save to HD!
Global $hBitmap = WebP_BitmapCreateGDIpFromMem($tMem.pMemData, $tMem.memsize, True)
Global $tDim = DllStructCreate($tagBITMAP)
DllCall("gdi32.dll", "int", "GetObject", "int", $hBitmap, "int", DllStructGetSize($tDim), "ptr", DllStructGetPtr($tDim))
Global Const $iW = DllStructGetData($tDim, "bmWidth"), $iH = DllStructGetData($tDim, "bmHeight")
Global Const $hGUI = GUICreate("WebP Image Viewer (Image size: " & Round($tMem.memsize / 1024, 2) & " kb)", $iW * 2, $iH)
GUISetBkColor(0xFFFFFF)
Global Const $iPic_WebP = GUICtrlCreatePic("", 0, 0, $iW - 1, $iH - 1)
Global Const $iPic_Original = GUICtrlCreatePic("", $iW, 0, $iW - 1, $iH - 1)
_WinAPI_DeleteObject(GUICtrlSendMsg($iPic_WebP, $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap))
_WinAPI_DeleteObject(GUICtrlSendMsg($iPic_Original, $STM_SETIMAGE, $IMAGE_BITMAP, $hHBitmap))
GUISetState()
_GDIPlus_ImageDispose($hImage)
_WinAPI_DeleteObject($hBitmap)
_WinAPI_DeleteObject($hHBitmap)
_GDIPlus_Shutdown()
WebP_FreeUp($tMem)

Do
Until GUIGetMsg() = $GUI_EVENT_CLOSE